## wml 2.12.2~ds1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)

INCLUDE ("${CMAKE_SOURCE_DIR}/cmake/shlomif_common_bootstrap.cmake")
SHLOMIF_COMMON_SETUP("${private_mod_path}")
# see - http://www.cmake.org/Wiki/CMake_FAQ#Is_there_an_option_to_produce_more_.27verbose.27_compiling.3F
# SET(CMAKE_VERBOSE_MAKEFILE ON)

SET(VERSION "2.12.2")

IF (NOT CMAKE_INSTALL_PREFIX)
    MESSAGE (FATAL_ERROR "CMAKE_INSTALL_PREFIX must be defined. Specify it with -DCMAKE_INSTALL_PREFIX=...")
ENDIF (NOT CMAKE_INSTALL_PREFIX)

INCLUDE(GNUInstallDirs)

SET (WML_LIB_DIR_BASE "${CMAKE_INSTALL_LIBDIR}")
set (p "${CMAKE_INSTALL_PREFIX}/")
string(FIND "${WML_LIB_DIR_BASE}" "${p}" _pos)
IF("${_pos}" EQUAL "0")
    string(LENGTH "${p}" _l)
    string(SUBSTRING "${WML_LIB_DIR_BASE}" "${_l}" -1 WML_LIB_DIR_BASE)
ENDIF()

SET (WML_LIB_DIR "${WML_LIB_DIR_BASE}/wml")
SET (WML_DATA_DIR "${WML_LIB_DIR}/data")
SET (WML_LIBEXE_DIR "${WML_LIB_DIR}/exec/")

# This is the equivalent to perform a "make dist"/"make distdir" etc.
SET(CPACK_PACKAGE_NAME "wml")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Website Meta Language")
SET(CPACK_PACKAGE_VENDOR "Shlomi Fish")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")

# Process and extract the version number.
# FILE( READ "ver.txt" VERSION)

CHOMP (VERSION)

STRING (REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")

LIST(GET VERSION_DIGITS 0 CPACK_PACKAGE_VERSION_MAJOR)
LIST(GET VERSION_DIGITS 1 CPACK_PACKAGE_VERSION_MINOR)
LIST(GET VERSION_DIGITS 2 CPACK_PACKAGE_VERSION_PATCH)

SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET (base_with_ver "${CPACK_PACKAGE_NAME}-[0-9]+\\\\.[0-9]+\\\\.[0-9]+")

SET(CPACK_SOURCE_GENERATOR "TXZ")
SET(CPACK_SOURCE_IGNORE_FILES
    "~$"
    "/\\\\.tidyall\\\\.d/"
    "/t/t/.*\\\\.exe$"
    "/tags$"
)

IF(WIN32 AND NOT UNIX)
    # There is a bug in NSI that does not handle full unix paths properly. Make
    # sure there is at least one set of four (4) backlasshes.
    # SET(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}\\\\dondorf-king.bmp")
    SET(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\wml.exe")
    SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\thewml.org")
    SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\thewml.org")
    SET(CPACK_NSIS_DISPLAY_NAME "Website Meta Language")
    SET(CPACK_NSIS_CONTACT "shlomif@cpan.org")
    SET(CPACK_NSIS_MODIFY_PATH ON)
    # Setting for NSIS :
    SET(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\wml.ico")
    SET(CPACK_NSIS_MUI_UNIICON ${CPACK_NSIS_MUI_ICON})
    SET(CPACK_PACKAGE_ICON ${CPACK_NSIS_MUI_ICON})
    SET(CPACK_NSIS_MODIFY_PATH "ON")
ELSE(WIN32 AND NOT UNIX)
    # SET(CPACK_STRIP_FILES "")
    # SET(CPACK_SOURCE_STRIP_FILES "")
ENDIF(WIN32 AND NOT UNIX)

SET(CPACK_PACKAGE_EXECUTABLES
    "wml" "Website Meta Language Frontend"
)

FIND_PROGRAM(_lynx NAMES "lynx")
IF (NOT _lynx)
    MESSAGE (FATAL_ERROR "lynx is required - please install it.")
ENDIF ()

INCLUDE (CPack)

SET (CPAN_MODULES_TO_CHECK
    "Bit::Vector"
    "Carp::Always"
    "Class::XSAccessor"
    "File::Which"
    "GD"
    "Getopt::Long"
    "Image::Size"
    "IO::All"
    "List::MoreUtils"
    "Path::Tiny"
    "Term::ReadKey"
    "Time::HiRes"
    )

CHECK_FOR_MULTIPLE_PERL_MODULES(${CPAN_MODULES_TO_CHECK})

ENABLE_TESTING()

ADD_SUBDIRECTORY( wml_aux )
ADD_SUBDIRECTORY( wml_backend )
ADD_SUBDIRECTORY( wml_docs )
ADD_SUBDIRECTORY( wml_frontend )
ADD_SUBDIRECTORY( wml_test )
ADD_SUBDIRECTORY( wml_include )
ADD_SUBDIRECTORY( wml_misc )

=== wml_aux/CMakeLists.txt ===
# see - http://www.cmake.org/Wiki/CMake_FAQ#Is_there_an_option_to_produce_more_.27verbose.27_compiling.3F
SET(CMAKE_VERBOSE_MAKEFILE ON)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

ADD_SUBDIRECTORY( iselect )
ADD_SUBDIRECTORY( htmlclean )
ADD_SUBDIRECTORY( htmlinfo )
ADD_SUBDIRECTORY( linklint )
ADD_SUBDIRECTORY( map2html )
ADD_SUBDIRECTORY( txt2html )
ADD_SUBDIRECTORY( weblint )
ADD_SUBDIRECTORY( freetable )

=== wml_backend/CMakeLists.txt ===
ADD_SUBDIRECTORY( p1_ipp )
ADD_SUBDIRECTORY( p2_mp4h )
ADD_SUBDIRECTORY( p3_eperl )
ADD_SUBDIRECTORY( p5_divert )
ADD_SUBDIRECTORY( p6_asubst )
ADD_SUBDIRECTORY( p7_htmlfix )
ADD_SUBDIRECTORY( p8_htmlstrip )
ADD_SUBDIRECTORY( p9_slice )

=== wml_docs/CMakeLists.txt ===
SET (STDS
    "wml_barebone"
    "wml_std_css1"
    "wml_std_css2"
    "wml_std_csspos"
    "wml_std_html20"
    "wml_std_html32"
    "wml_std_html40"
    "wml_std_html401"
    "wml_std_wai10"
    "wml_std_xhtml10"
    )

SET (WML_DOCS
    "wml_intro"
    "wml_tutorial"
    "wml_macros"
    "wml_faq"
    "wml_tags"
)

FOREACH(MYSTD ${STDS})
    SET (TXT_SRC "${MYSTD}.txt")
    SET (MAN7_LOCAL "${MYSTD}.7")

    # MESSAGE (FATAL_ERROR "${CMAKE_CURRENT_BINARY_DIR}/${MAN7_LOCAL}")
    ADD_COPY_TARGET("std_copy_${MYSTD}" "${CMAKE_CURRENT_SOURCE_DIR}/${TXT_SRC}" "${CMAKE_CURRENT_BINARY_DIR}/${MAN7_LOCAL}")

    INSTALL_CAT_MAN("${MAN7_LOCAL}" "7")

ENDFOREACH(MYSTD ${STDS})

# MESSAGE (FATAL_ERROR "CUR_BIN = ${CMAKE_CURRENT_BINARY_DIR}")
SET (TAGS_POD "${CMAKE_CURRENT_BINARY_DIR}/wml_tags.pod")
ADD_CUSTOM_COMMAND(
    OUTPUT "${TAGS_POD}"
    COMMAND ${PERL_EXECUTABLE}
    ARGS "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.pod.pl"
        "--src" "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.pod.in"
        "--dest" "${TAGS_POD}"
        "--main" "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.L.main"
        "--incl" "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.L.incl"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.pod.in"
            "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.L.main"
            "${CMAKE_CURRENT_SOURCE_DIR}/wml_tags.L.incl"
    VERBATIM
)

# The custom command needs to be assigned to a target.
ADD_CUSTOM_TARGET(
    ${TARGET_NAME} ALL
    DEPENDS ${TAGS_POD}
)

SET (pod_dests )

FOREACH(MYDOC ${WML_DOCS})
    SET (POD_SRC "${MYDOC}.pod")
    SET (MAN_LOCAL "${MYDOC}")

    IF (${MYDOC} STREQUAL "wml_tags")
        SET (POD2MAN_SOURCE_IS_IN_BINARY 1)
    ENDIF (${MYDOC} STREQUAL "wml_tags")
    INST_POD2MAN("pod_dests" "${POD_SRC}" "${MAN_LOCAL}" "7")
ENDFOREACH(MYDOC ${WML_DOCS})

ADD_CUSTOM_TARGET(
    "docs_pods" ALL
    DEPENDS ${pod_dests}
)

=== wml_frontend/CMakeLists.txt ===
SET (username "unknown")

EXECUTE_PROCESS(COMMAND "whoami"
    OUTPUT_VARIABLE username
)

CHOMP(username)

EXECUTE_PROCESS(COMMAND "${PERL_EXECUTABLE}"
    "-MPOSIX" "-e" "print strftime('%Y-%m-%d', localtime())"
    OUTPUT_VARIABLE date
)

MACRO(set_vars)
    SET (destbase "${cmd}.pl")
    SET (dest "${CMAKE_CURRENT_BINARY_DIR}/${destbase}")
    SET (srcbase "${cmd}.src")
    SET (src "${CMAKE_CURRENT_SOURCE_DIR}/${srcbase}")
    SET (mannamebase "${cmd}")
    SET (manname "${CMAKE_CURRENT_BINARY_DIR}/${mannamebase}")
ENDMACRO(set_vars)

SET (pod_dests )

MACRO(PREPROCESS_PATH_PERL_WITH_FULL_NAMES__AND_WITH_POD TARGET_NAME SOURCE DEST)
    ADD_CUSTOM_COMMAND(
        OUTPUT "${DEST}"
        COMMAND "${PERL_EXECUTABLE}"
        ARGS "${CMAKE_SOURCE_DIR}/cmake/preprocess-path-perl.pl"
            "--input" "${SOURCE}"
            "--output" "${DEST}"
            "--subst" "WML_VERSION=${VERSION}"
            "--subst" "WML_CONFIG_ARGS="
            "--subst" "perlprog=${PERL_EXECUTABLE}"
            "--subst" "perlvers=${PERL_EXECUTABLE}"
            "--subst" "built_system=${CMAKE_SYSTEM_NAME}"
            "--subst" "built_user=${username}"
            "--subst" "built_date=${date}"
            "--subst" "prefix=${CMAKE_INSTALL_PREFIX}"
            "--subst" "bindir=${CMAKE_INSTALL_PREFIX}/bin"
            "--subst" "libdir=${CMAKE_INSTALL_PREFIX}/${WML_LIB_DIR}"
            "--subst" "mandir=${CMAKE_INSTALL_PREFIX}/share/man"
            "--subst" "PATH_PERL=${PERL_EXECUTABLE}"
            "--subst" "INSTALLPRIVLIB=${CMAKE_INSTALL_PREFIX}/${WML_LIB_DIR}"
            "--subst" "INSTALLARCHLIB=${CMAKE_INSTALL_PREFIX}/${WML_LIB_DIR}"
            "--discardpod=0"
        COMMAND chmod ARGS "a+x" "${DEST}"
        DEPENDS "${SOURCE}"
    )
    # The custom command needs to be assigned to a target.
    ADD_CUSTOM_TARGET(
        ${TARGET_NAME} ALL
        DEPENDS ${DEST}
    )
ENDMACRO()

FOREACH (cmd wmk wml wmb wmd wmu wml-params-conf)
    set_vars()
    # MESSAGE( FATAL_ERROR "WML_LIB_DIR = ${WML_LIB_DIR}")
    # IF ("${cmd}" STREQUAL "wml-params-conf")
    IF (TRUE)
        PREPROCESS_PATH_PERL_WITH_FULL_NAMES__AND_WITH_POD("preprocess_perl_frontend_${cmd}" "${src}" "${dest}")
    ELSE()
        PREPROCESS_PATH_PERL_WITH_FULL_NAMES("preprocess_perl_frontend_${cmd}" "${src}" "${dest}")
    ENDIF()
    INSTALL (
        PROGRAMS "${dest}"
        DESTINATION "bin"
        RENAME "${cmd}"
        )
    SET (POD2MAN_SOURCE_IS_IN_BINARY "1")
    INST_POD2MAN("pod_dests" "${destbase}" "${mannamebase}" "1")
ENDFOREACH(cmd)

FOREACH(cmd wmd_missing)
    set_vars()
    INST_POD2MAN("pod_dests" "${srcbase}" "${mannamebase}" "1")
ENDFOREACH(cmd)

ADD_CUSTOM_TARGET(
    "frontend_pods" ALL
    DEPENDS ${pod_dests}
)

INSTALL_DATA ("wmd.txt")

=== wml_include/CMakeLists.txt ===
SET (myfiles
    all
    des/all
    des/gfont
    des/imgbg
    des/imgdot
    des/lowsrc
    des/navbar
    des/preload
    des/rollover
    des/space
    des/typography
    fmt/all
    fmt/isolatin
    fmt/pod
    fmt/sdf
    fmt/text
    fmt/url
    fmt/verbatim
    fmt/xtable
    imp/all
    imp/csmap
    imp/fsview
    imp/generic
    mod/all
    mod/MakeMaker
    mod/version
    std/all
    std/box
    std/case
    std/grid
    std/href
    std/info
    std/label
    std/lang
    std/logo
    std/page
    std/tags
    std/toc
    sup/all
    sup/hextriple
    sup/path
    sys/all
    sys/bootp3
    sys/bootp4
    sys/compat1
)

CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/sys/bootp3.src.in"
    "${CMAKE_CURRENT_BINARY_DIR}/sys/bootp3.src"
    COPYONLY
)

SET (dirs_to_make )
SET (preproc_target_dests )
SET (include_pods_dests )

FOREACH (base ${myfiles})

    # Make the directory to which the file belongs.
    STRING (REGEX REPLACE "/.*" "" basedir "${base}")
    LIST (FIND dirs_to_make "${basedir}" found)
    IF ("${found}" STREQUAL "-1")
        LIST (APPEND dirs_to_make "${basedir}")
        FILE (MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${basedir}")
    ENDIF ("${found}" STREQUAL "-1")

    SET (destbase "${base}.wml")
    SET (dest "${CMAKE_CURRENT_BINARY_DIR}/${destbase}")
    SET (srcbase "${base}.src")
    IF ("${base}" STREQUAL "sys/bootp3")
        SET (src "${CMAKE_CURRENT_BINARY_DIR}/${srcbase}")
        SET (is_binary 1)
        # MESSAGE (FATAL_ERROR "src = ${src}")
    ELSE ("${base}" STREQUAL "sys/bootp3")
        SET (src "${CMAKE_CURRENT_SOURCE_DIR}/${srcbase}")
        SET (is_binary )
    ENDIF ("${base}" STREQUAL "sys/bootp3")
    SET (mannamebase "${base}")
    SET (manname "${CMAKE_CURRENT_BINARY_DIR}/${mannamebase}")

    STRING (REPLACE "/" "__" target_base "${base}")


    ADD_CUSTOM_COMMAND(
        OUTPUT "${dest}"
        COMMAND "${PERL_EXECUTABLE}"
        ARGS "${CMAKE_CURRENT_SOURCE_DIR}/preprocess-perl-source.pl"
            "--input" "${src}"
            "--output" "${dest}"
        DEPENDS "${src}"
    )
    LIST (APPEND preproc_target_dests "${dest}")
    INSTALL (
        FILES "${dest}"
        DESTINATION "${WML_LIB_DIR}/include/"
        RENAME "${destbase}"
    )
    STRING (REPLACE "/" "::" dest_man "wml/${base}")

    IF (is_binary)
        SET (POD2MAN_SOURCE_IS_IN_BINARY 1)
    ENDIF (is_binary)
    INST_RENAME_POD2MAN(
        "include_pods_dests"
        "${srcbase}"
        "${mannamebase}"
        "3"
        "${dest_man}"
    )
ENDFOREACH(base)

FILE(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/TheWML/Frontends/Wml/")
PREPROCESS_PATH_PERL_WITH_FULL_NAMES("preprocess_perl_include_config" "${CMAKE_CURRENT_SOURCE_DIR}/TheWML/Config.pm.src" "${CMAKE_CURRENT_BINARY_DIR}/TheWML/Config.pm")
INSTALL (
    FILES
        "${CMAKE_CURRENT_BINARY_DIR}/TheWML/Config.pm"
    DESTINATION "${WML_LIB_DIR}/TheWML"
)
FOREACH( fn
        "TheWML/Backends/ASubst/Main.pm"
        "TheWML/Backends/Divert/Main.pm"
        "TheWML/Backends/Fixup/Main.pm"
        "TheWML/Backends/HtmlStrip/Main.pm"
        "TheWML/Backends/IPP/Args.pm"
        "TheWML/Backends/IPP/Delimit.pm"
        "TheWML/Backends/IPP/File.pm"
        "TheWML/Backends/IPP/Line.pm"
        "TheWML/Backends/IPP/Main.pm"
        "TheWML/Backends/IPP/Map.pm"
        "TheWML/CmdLine/Base.pm"
        "TheWML/CmdLine/IO.pm"
        "TheWML/Frontends/Wml/OptD.pm"
        "TheWML/Frontends/Wml/PassObj.pm"
        "TheWML/Frontends/Wml/PassesManager.pm"
        "TheWML/Frontends/Wml/Protect.pm"
        "TheWML/Frontends/Wml/Runner.pm"
        "TheWML/Frontends/Wml/Util.pm"
        "TheWML/Frontends/Wml/WmlRc.pm"
        "TheWML/Frontends/Wml/WmlRcDir.pm"
        )
    get_filename_component(_dir "${fn}" DIRECTORY)
    INSTALL(
        FILES "${fn}"
        DESTINATION "${WML_LIB_DIR}/${_dir}"
    )
ENDFOREACH()

ADD_CUSTOM_TARGET(
    "preprocess_perl_includes" ALL
    DEPENDS ${preproc_target_dests}
)

ADD_CUSTOM_TARGET(
    "includes_pods" ALL
    DEPENDS ${include_pods_dests}
)

=== wml_misc/CMakeLists.txt ===
SET (LOGO_FILES
    logo-apache.gif
    logo-apache.info
    logo-apache.png
    logo-freebsd.gif
    logo-freebsd.info
    logo-freebsd.png
    logo-gimp.gif
    logo-gimp.info
    logo-gimp.png
    logo-htdig.gif
    logo-htdig.info
    logo-htdig.png
    logo-linux.gif
    logo-linux.info
    logo-linux.png
    logo-netbsd.gif
    logo-netbsd.info
    logo-netbsd.png
    logo-openbsd.gif
    logo-openbsd.info
    logo-openbsd.png
    logo-php3.gif
    logo-php3.info
    logo-php3.png
    logo-php.gif
    logo-php.info
    logo-php.png
    logo-vim.gif
    logo-vim.info
    logo-vim.png
    logo-wml.gif
    logo-wml.info
    logo-wml.png
    logo-xemacs.gif
    logo-xemacs.info
    logo-xemacs.png
)

INSTALL(
    FILES
        ${LOGO_FILES}
    DESTINATION
        "${WML_DATA_DIR}/logos"
)

=== wml_test/CMakeLists.txt ===
SET (_test_cmd_cmd_line "make" "-f" "test.mak" "test"
    "PATH_PERL=${PERL_EXECUTABLE}"
    "prefix=${CMAKE_INSTALL_PREFIX}"
    "srcdir=${CMAKE_CURRENT_SOURCE_DIR}"
    "top_srcdir=${CMAKE_SOURCE_DIR}"
    )

SET (_test_cmd_cmd_line "${PERL_EXECUTABLE}"
    "${CMAKE_CURRENT_SOURCE_DIR}/run_test.pl"
)

ADD_TEST(
    NAME wml_tests
    COMMAND ${_test_cmd_cmd_line}
)

ADD_CUSTOM_TARGET(
    "check"
    ${_test_cmd_cmd_line}
    VERBATIM
)

=== wml_aux/htmlinfo/CMakeLists.txt ===
DEFINE_WML_AUX_PERL_PROG("htmlinfo")

=== wml_aux/map2html/CMakeLists.txt ===
DEFINE_WML_AUX_PERL_PROG("map2html")

=== wml_backend/p5_divert/CMakeLists.txt ===
DEFINE_WML_PERL_BACKEND("divert" "wml_p5_divert")

=== wml_backend/p7_htmlfix/CMakeLists.txt ===
DEFINE_WML_PERL_BACKEND("htmlfix" "wml_p7_htmlfix")

=== debian/changelog ===
wml (2.12.2~ds1-2) unstable; urgency=medium

  * Recommend libgd-perl: wml::des::imgbg now uses GD.pm instead of the
    vanished WML::GD which used the C library libgd3 directly. Thanks to
    Kurt Roeckx for the bug report! (Closes: #922507)
  * Install all files except the .spec files from wml_contrib into
    /usr/share/wml/contrib/ instead of /usr/share/doc/wml/wml_contrib/.
    + Make tkwmd executable via override and suggest perl-tk for it.
    + Replace ancient workaround with proper shebang line in wml1to2.
    + Add lintian override for /usr/share/wml/contrib/README.

 -- Axel Beckert <abe@debian.org>  Sun, 17 Feb 2019 18:39:38 +0100

wml (2.12.2~ds1-1) unstable; urgency=medium

  * New upstream bug fix release.
    + Drop wml_test/test.mak from test installation list.
    + debian/docs: Follow renaming from README to README.md.
    + Drop man page uncompression from debian/tests/upstream-tests as
      wml_test/t/man-pages.t is gone.
  * Add patch to fix old typos found by new lintian.

 -- Axel Beckert <abe@debian.org>  Tue, 29 Jan 2019 02:14:17 +0100

wml (2.12.1~ds1-1) unstable; urgency=medium

  * Import new upstream release 2.12.1.
    + Drop fix-man-page-sections-and-see-also.diff, manpage-fixes.diff,
      reproducible-build.diff, fix-test-suite-warning.patch, and
      ignore-subsecond-difference-issues-in-wmk-test.patch; applied
      upstream or fixed otherwise.
    + Refresh datadir-for-cmake-too.diff.
    + Update debian/tests/upstream-tests to install the wmk man
      page from package into the test tree, just uncompressed.

 -- Axel Beckert <abe@debian.org>  Sun, 13 Jan 2019 17:29:01 +0100

wml (2.12.0~ds1-5) unstable; urgency=medium

  * debian/rules: Use DEB_HOST_* instead of DEB_TARGET_* for build and
    installation directory names. (Closes: #918617) Thanks Guillem Jover!

 -- Axel Beckert <abe@debian.org>  Tue, 08 Jan 2019 06:28:00 +0100

wml (2.12.0~ds1-4) unstable; urgency=medium

  * Add missing dependencies on libio-all-perl and liblist-moreutils-perl.
    (Closes: #918398) Thanks Adrian Bunk!
  * Drop all *-dev build-dependencies. No more needed since actually the
    switch to "Architecture: all".
  * Drop "<!nocheck>" from all build-dependencies for which CMake checks.
  * Add all (test-suite-related) build-dependencies which are checked by
    CMake, namely libbit-vector-perl and liblist-moreutils-perl (not yet,
    see https://github.com/thewml/website-meta-language/pull/23).
  * override_dh_auto_test: For now, check both, DEB_BUILD_OPTIONS and
    DEB_BUILD_PROFILES, see
    https://lists.debian.org/debian-devel/2019/01/msg00039.html ff.

 -- Axel Beckert <abe@debian.org>  Sun, 06 Jan 2019 03:49:04 +0100

wml (2.12.0~ds1-3) unstable; urgency=medium

  * Use DEB_TARGET_MULTIARCH instead of DEB_TARGET_GNU_TYPE in
    debian/rules' install target to fix FTBFS on i386 (and possibly other
    architectures). Thanks to the Reproducible Builds project for having
    tested this.

 -- Axel Beckert <abe@debian.org>  Sat, 05 Jan 2019 02:29:51 +0100

wml (2.12.0~ds1-2) unstable; urgency=low

  * Extend reproducible-build.diff: Patch cmake/pod2man-wrapper.pl to not
    put the build directory name into the man page title.

 -- Axel Beckert <abe@debian.org>  Tue, 01 Jan 2019 02:36:39 +0100

wml (2.12.0~ds1-1) unstable; urgency=low

  * Upload to unstable again.
  * Fix oversionmangle regexp in debian/watch.
  * New upstream release.
    + Drop all patches added in the previous upload, applied upstream.
    + Drop wmu.src hunk from fix-man-page-sections-and-see-also.diff, wmu
      has been deprecated and has no more function.
    + Refresh patches.
  * Update Homepage header to HTTPS.
  * Drop horribly outdated debian/TODO. (Last modified over 8 years ago.)
  * Don't install deprecated and now no-op wmu.
  * Make package autopkgtestable with the upstream test suite.
    + Add patch to fix unnecessary test suite warning on STDERR.
    + Make t/11-wmk.t not bail out due subsecond time difference. This is
      likely related to #675855 which caused me to disable that test for
      Debian until upstream did so, too.
  * Bump debhelper compatibility level to 12.
    + Drop debian/compat file and use a versioned build-dependency on
      debhelper-compat instead.
  * Merge 2.0.12ds1-10 to 2.0.12ds1-13 legacy uploads:
    + Drop htmlfix_imgsize.diff (from 2.0.12ds1-13), applied upstream.
    + Drop "-b cmake" from Vcs-Git header.
    + Keep DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow (from 2.0.12ds1-10)
      since the package will likely switch back to arch:any after the Buster
      release.
    + reproducible-build.diff: Update from wml_frontend/wml.src to
      wml_include/TheWML/Config.pm.src. (Merge "Also remove name of the
      build host" from 2.0.12ds1-10.)
  * Add a DEP-12 debian/upstream/metadata file.

 -- Axel Beckert <abe@debian.org>  Mon, 31 Dec 2018 19:49:19 +0100

wml (2.10.1~ds1-1) experimental; urgency=low

  * Fix wrong bug number in previous changelog entry.
  * Declare compliance with Debian Policy 4.3.0. (No changes needed.)
  * Mention new github.com repository in debian/copyright.
  * Update Vcs-* headers for packaging repository moving to Salsa.
  * Drop one-man-team from Maintainer field, set myself personally there
    instead. (Closes: #899725)
  * Add "-b cmake" to Vcs-Git until this package is uploaded to unstable.
  * Check DEB_BUILD_OPTIONS for nocheck running test suite preparations.
  * Update debian/watch to point to releases in Github repository.
  * Import new upstream release 2.10.0.
    + Drop many hunks as a lot of autotools related files were removed.
    + Refresh patches as necessary.
    + Drop patches do-not-touch-problematic-files.diff,
      fix-testsuite.diff, fix-WML_VERSION-in-manpage.diff, and
      fix-test-suite-makefile.diff, fixup-non-free-stuff-removal.diff,
      no more needed.
    + Drop remove-tmp-ipp-directories.diff and all wml_frontend/wml.src


=== debian/control ===
Source: wml
Section: web
Priority: optional
Maintainer: Axel Beckert <abe@debian.org>
Standards-Version: 4.3.0
Build-Depends: cmake,
               debhelper-compat (= 12),
               eperl <!nocheck>,
               freetable <!nocheck>,
               libbit-vector-perl,
               libclass-xsaccessor-perl,
               libcarp-always-perl,
               libcode-tidyall-perl <!nocheck>,
               libfile-which-perl,
               libgd-gd2-perl,
               libhtml-clean-perl,
               libimage-size-perl,
               libio-all-perl,
               liblist-moreutils-perl,
               libpath-tiny-perl,
               libperl-critic-perl <!nocheck>,
               libterm-readkey-perl,
               linklint <!nocheck>,
               lynx | lynx-cur,
               m4 <!nocheck>,
               mp4h <!nocheck>,
               perl (>= 5.8.0),
               slice <!nocheck>,
               txt2html <!nocheck>,
               weblint-perl <!nocheck>,
               zlib1g-dev
Homepage: https://www.shlomifish.org/open-source/projects/website-meta-language/
Vcs-Browser: https://salsa.debian.org/debian/wml
Vcs-Git: https://salsa.debian.org/debian/wml.git
Rules-Requires-Root: no

Package: wml
Architecture: all
Depends: eperl (>= 2.2.14-2),
         libclass-xsaccessor-perl,
         libbit-vector-perl,
         libcarp-always-perl,
         libfile-which-perl,
         libimage-size-perl,
         libio-all-perl,
         liblist-moreutils-perl,
         libpath-tiny-perl,
         libterm-readkey-perl,
         m4 (>= 1.4-8),
         mp4h (>= 1.1.1-1),
         slice (>= 1.3.7-0.1),
         ${misc:Depends},
         ${perl:Depends}
Recommends: iselect (>= 1.2.0-2),
            libgd-perl,
            libhtml-clean-perl (>= 0.7-3),
            linklint,
            tidy (>= 19990415-1),
            txt2html
Suggests: freetable,
          imagemagick,
          libwww-perl,
          perl-tk,
          shtool (>= 1.5.1-1),
          tardy,
          w3-recs,
          weblint-perl
Description: off-line HTML generation toolkit
 WML (Website META Language) is a free and extensible Webdesigner's
 off-line HTML generation toolkit for Unix.  WML consists of a control
 frontend driving up to nine backends in a sequential pass-oriented
 filtering scheme. Each backend provides one particular core language.
 For maximum power WML additionally ships with a well-suited set of
 include files which provide higher-level features build on top of the
 backends core languages. While not trivial and idiot proof WML provides
 most of the core features real hackers always wanted for HTML
 generation.

=== debian/rules ===
#!/usr/bin/make -f

SHELL = /bin/sh

r = $(shell pwd)/debian/wml
t = $(shell pwd)/debian/tmp
o = $(shell pwd)/obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
m = $(r)/usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
p = wml

# Repackaging variables
DEBIAN_REVISION := $(shell echo -n `head -1 debian/changelog | sed -e 's/^.*(\(.*\)).*$$/\\1/'`)
DEBIAN_VERSION := $(shell echo -n $(DEBIAN_REVISION) | sed -e 's/-.*//')
UPSTREAM_VERSION := $(shell echo -n $(DEBIAN_VERSION) | sed -e 's/ds[0-9]$$//')
UPSTREAM_DIR := "$(t)/wml-$(UPSTREAM_VERSION)"
DEBIAN_DIR := "$(t)/wml-$(UPSTREAM_VERSION).orig"

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_INSTALL_DIR=dummy

override_dh_auto_install:
	dh_auto_install -- prefix=$(r)/usr mandir=$(r)/usr/share/man INSTALLDIRS=perl
	# Install icons for wml::std::logo
	dh_auto_install -Dwml_misc -- libdir=$(r)/usr/share/wml

	find $(r)/usr -type f -name .packlist -delete
	find $(r) -type d -empty -delete
	mv -v $(m)/wml $(r)/usr/share/
	#   Fix documentation
	for f in $(r)/usr/share/man/*/*; do \
	   sed -e 's|.*/\([^/	]*\)	.*/\([^/	]*\)|s/\2/\1/|' debian/links |\
	   sed -f - $$f > $$f.new && mv $$f.new $$f; \
	done
	rmdir -v $(m)/
	# Don't ship wmu nor its man pages, its useless in distro (and deprecated anyways)
	rm -f debian/wml/usr/share/man/man1/wmu.1* debian/wml/usr/bin/wmu

override_dh_install:
	dh_install
	chmod 755 $(r)/usr/share/wml/contrib/tkwmd

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	cp -pvr wml_test/TEST* wml_test/t $(o)/wml_test/
	mkdir -pv $(o)/wml_test/tests/installation/lib/wml/exec/
	ln -vis $(o)/wml_test/tests/installation/lib $(o)/wml_test/tests/installation/share
	mkdir -pv $(o)/wml_test/tests/installation/bin/
	for i in $(o)/wml_frontend/*.pl; do \
	    cp -pv $$i $(o)/wml_test/tests/installation/bin/`basename $$i .pl`; \
	done
	cp -pv $(o)/wml_backend/p1_ipp/ipp.pl             $(o)/wml_test/tests/installation/lib/wml/exec/wml_p1_ipp
	cp -pv $(o)/wml_backend/p5_divert/divert.pl       $(o)/wml_test/tests/installation/lib/wml/exec/wml_p5_divert
	cp -pv $(o)/wml_backend/p6_asubst/asubst.pl       $(o)/wml_test/tests/installation/lib/wml/exec/wml_p6_asubst
	cp -pv $(o)/wml_backend/p7_htmlfix/htmlfix.pl     $(o)/wml_test/tests/installation/lib/wml/exec/wml_p7_htmlfix
	cp -pv $(o)/wml_backend/p8_htmlstrip/htmlstrip.pl $(o)/wml_test/tests/installation/lib/wml/exec/wml_p8_htmlstrip
	mkdir -pv $(o)/wml_test/tests/installation/lib/perl5/include/ $(o)/wml_test/tests/installation/share/wml/include/
	cp -pvr wml_include/TheWML/ $(o)/wml_test/tests/installation/lib/perl5/
	cp -pvr $(o)/wml_include/TheWML/ $(o)/wml_test/tests/installation/lib/perl5/
	cp -pvr $(o)/wml_include/???/ $(o)/wml_include/all.wml $(o)/wml_test/tests/installation/share/wml/include/
	#dh_auto_install -- prefix=$(o)/wml_test/tests/installation/
	ln -vis /usr/bin/mp4h  $(o)/wml_test/tests/installation/lib/wml/exec/wml_p2_mp4h
	ln -vis /usr/bin/eperl $(o)/wml_test/tests/installation/lib/wml/exec/wml_p3_eperl
	ln -vis /usr/bin/m4    $(o)/wml_test/tests/installation/lib/wml/exec/wml_p4_gm4
	ln -vis /usr/bin/slice $(o)/wml_test/tests/installation/lib/wml/exec/wml_p9_slice
	sed -e 's:/usr/\(lib\|share\)/wml:$(o)/wml_test/tests/installation/\1/wml:g; s:\(WML_LOC_.*\)=/usr:\1=$(o)/wml_test/tests/installation:g;' \
	    -i $(o)/wml_test/tests/installation/bin/wm? \
	       $(o)/wml_test/tests/installation/lib/wml/exec/wml_p* \
	       $(o)/wml_test/tests/installation/lib/perl5/TheWML/*.pm \
	       $(o)/wml_test/tests/installation/lib/perl5/TheWML/*/*.pm \
	       $(o)/wml_test/tests/installation/lib/perl5/TheWML/*/*/*.pm
	dh_auto_test
endif

override_dh_installdocs:
	dh_installdocs
	find $(r) '(' -name '*.spec' -o -name '*.spec.in' ')' -delete

override_dh_perl:
	dh_perl usr/lib/wml/perl/lib

########################################################
### The remainder is just the get-orig-source target ###
########################################################
get-orig-source:
	# Prepare repackaging directory
	rm -rf $(t)
	mkdir -p $(t)
	# Unpack tar ball as downloaded by uscan(1)
	tar xvj -C $(t) -f ../wml_$(UPSTREAM_VERSION).orig.tar.bz2
	# Rename directory
	mv -v $(UPSTREAM_DIR) $(DEBIAN_DIR)

	# We don't want upstream VCS stuff in our orig.tar.bz2
	-find $(DEBIAN_DIR) -name .svn -exec rm -rvf '{}' ';'

	# Also remove stuff which should not belong in the upstream
	# distribution files either.
	find $(DEBIAN_DIR) -name '*~' -exec rm -vf '{}' ';'
	find $(DEBIAN_DIR) -name '*.tmp' -exec rm -rvf '{}' ';'

	# Remove stuff which will be removed by make distclean anyway
	find $(DEBIAN_DIR) -mindepth 1 -name '*.orig' -exec rm -rvf '{}' ';'
	rm -rvf $(DEBIAN_DIR)/wml_backend/p2_mp4h/autom4te.cache

	# Remove non-free stuff
	rm -vf $(DEBIAN_DIR)/wml_docs/wml_std_*.txt
	rm -vf $(DEBIAN_DIR)/wml_docs/wml_barebone.txt

	# This was maybe not the brightest idea, if one wants to
	# switch to dh-autoreconf...
	find $(DEBIAN_DIR) -name 'configure.in' -exec rm -vf '{}' ';'

	# Remove all embedded code copies not needed to build the
	# Debian package.
	rm -vf $(DEBIAN_DIR)/config/aclocal.m4
	rm -vf $(DEBIAN_DIR)/config/configure*
	rm -vf $(DEBIAN_DIR)/config/prep_modules_files.sh
	rm -rvf $(DEBIAN_DIR)/wml_aux/freetable
	rm -rvf $(DEBIAN_DIR)/wml_aux/txt2html
	rm -rvf $(DEBIAN_DIR)/wml_aux/htmlclean
	rm -rvf $(DEBIAN_DIR)/wml_aux/iselect
	rm -rvf $(DEBIAN_DIR)/wml_aux/linklint
	rm -rvf $(DEBIAN_DIR)/wml_aux/tidy
	rm -rvf $(DEBIAN_DIR)/wml_aux/weblint
	rm -rvf $(DEBIAN_DIR)/wml_backend/p2_mp4h
	rm -rvf $(DEBIAN_DIR)/wml_backend/p3_eperl
	rm -rvf $(DEBIAN_DIR)/wml_backend/p4_gm4
	rm -rvf $(DEBIAN_DIR)/wml_backend/p9_slice
	rm -rvf $(DEBIAN_DIR)/wml_common/bitvector
	rm -rvf $(DEBIAN_DIR)/wml_common/gd/libgd
	rm -rvf $(DEBIAN_DIR)/wml_common/getoptlong
	rm -rvf $(DEBIAN_DIR)/wml_common/imagesize
	rm -rvf $(DEBIAN_DIR)/wml_common/io
	rm -rvf $(DEBIAN_DIR)/wml_common/htmlclean
	rm -rvf $(DEBIAN_DIR)/wml_common/termreadkey
	# Do not remove wml_test for now.

	# Pack the Debian Source
	tar cv -C $(t) -f ../wml_$(DEBIAN_VERSION).orig.tar \
		wml-$(UPSTREAM_VERSION).orig
	bzip2 -9vf ../wml_$(DEBIAN_VERSION).orig.tar

	# Clean up again
	rm -rf $(t)

## wml 2.28.0~ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,19 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
+PROJECT(wml)
 
 INCLUDE ("${CMAKE_SOURCE_DIR}/cmake/shlomif_common_bootstrap.cmake")
 SHLOMIF_COMMON_SETUP("${private_mod_path}")
+INCLUDE ("${CMAKE_SOURCE_DIR}/cmake/thewml.cmake")
 # see - http://www.cmake.org/Wiki/CMake_FAQ#Is_there_an_option_to_produce_more_.27verbose.27_compiling.3F
 # SET(CMAKE_VERBOSE_MAKEFILE ON)
 
-SET(VERSION "2.12.2")
+SET (CPU_ARCH "" CACHE STRING "A specific CPU architecture to pass to gcc")
+option (OPTIMIZATION_OMIT_FRAME_POINTER "Use -fomit-frame-pointer with gcc (not recommended for debugging)")
+SET (PKGDATADIR_SUBDIR "wml")
+SET (RELATIVE_PKGDATADIR "${RELATIVE_DATADIR}/${PKGDATADIR_SUBDIR}")
+SET (PKGDATADIR "${DATADIR}/${PKGDATADIR_SUBDIR}")
+
+SET(VERSION "2.28.0")
 
 IF (NOT CMAKE_INSTALL_PREFIX)
     MESSAGE (FATAL_ERROR "CMAKE_INSTALL_PREFIX must be defined. Specify it with -DCMAKE_INSTALL_PREFIX=...")
@@ -22,7 +30,7 @@
 ENDIF()
 
 SET (WML_LIB_DIR "${WML_LIB_DIR_BASE}/wml")
-SET (WML_DATA_DIR "${WML_LIB_DIR}/data")
+SET (WML_DATA_DIR "${PKGDATADIR}/data")
 SET (WML_LIBEXE_DIR "${WML_LIB_DIR}/exec/")
 
 # This is the equivalent to perform a "make dist"/"make distdir" etc.
@@ -72,10 +80,10 @@
     SET(CPACK_NSIS_MUI_UNIICON ${CPACK_NSIS_MUI_ICON})
     SET(CPACK_PACKAGE_ICON ${CPACK_NSIS_MUI_ICON})
     SET(CPACK_NSIS_MODIFY_PATH "ON")
-ELSE(WIN32 AND NOT UNIX)
+ELSE()
     # SET(CPACK_STRIP_FILES "")
     # SET(CPACK_SOURCE_STRIP_FILES "")
-ENDIF(WIN32 AND NOT UNIX)
+ENDIF()
 
 SET(CPACK_PACKAGE_EXECUTABLES
     "wml" "Website Meta Language Frontend"
@@ -107,6 +115,14 @@
 
 ENABLE_TESTING()
 
+FUNCTION(RUN_ASC2C src dest varname)
+    ADD_CUSTOM_COMMAND(
+        COMMAND ${PERL_EXECUTABLE} ${CMAKE_SOURCE_DIR}/scripts/asc2c "${src}" "${dest}" "${varname}"
+        OUTPUT "${dest}.c"
+        DEPENDS "${src}"
+    )
+ENDFUNCTION()
+
 ADD_SUBDIRECTORY( wml_aux )
 ADD_SUBDIRECTORY( wml_backend )
 ADD_SUBDIRECTORY( wml_docs )

=== wml_frontend/CMakeLists.txt ===
SET (username "unknown")

EXECUTE_PROCESS(COMMAND "whoami"
    OUTPUT_VARIABLE username
)

CHOMP(username)

EXECUTE_PROCESS(COMMAND "${PERL_EXECUTABLE}"
    "-MPOSIX" "-e" "print strftime('%Y-%m-%d', localtime())"
    OUTPUT_VARIABLE date
)

MACRO(set_vars)
    SET (destbase "${cmd}.pl")
    SET (dest "${CMAKE_CURRENT_BINARY_DIR}/${destbase}")
    SET (srcbase "${cmd}.src")
    SET (src "${CMAKE_CURRENT_SOURCE_DIR}/${srcbase}")
    SET (mannamebase "${cmd}")
    SET (manname "${CMAKE_CURRENT_BINARY_DIR}/${mannamebase}")
ENDMACRO(set_vars)

SET (pod_dests )


FOREACH (cmd wmk wml wmb wmd wmu wml-params-conf)
    set_vars()
    # MESSAGE( FATAL_ERROR "WML_LIB_DIR = ${WML_LIB_DIR}")
    # IF ("${cmd}" STREQUAL "wml-params-conf")
    SET(PREPROCESS_PATH_PERL__ARGS "--discardpod=0")
    PREPROCESS_PATH_PERL_WITH_FULL_NAMES("preprocess_perl_frontend_${cmd}" "${src}" "${dest}")
    SET(PREPROCESS_PATH_PERL__ARGS )
    INSTALL (
        PROGRAMS "${dest}"
        DESTINATION "${CMAKE_INSTALL_BINDIR}"
        RENAME "${cmd}"
        )
    SET (POD2MAN_SOURCE_IS_IN_BINARY "1")
    INST_POD2MAN("pod_dests" "${destbase}" "${mannamebase}" "1")
ENDFOREACH(cmd)

FOREACH(cmd wmd_missing)
    set_vars()
    INST_POD2MAN("pod_dests" "${srcbase}" "${mannamebase}" "1")
ENDFOREACH(cmd)

ADD_CUSTOM_TARGET(
    "frontend_pods" ALL
    DEPENDS ${pod_dests}
)

INSTALL_DATA ("wmd.txt")

=== debian/changelog ===
wml (2.28.0~ds1-2) unstable; urgency=low

  * Retroactively mention #916519 in the 2.10.1~ds1-1 changelog entry.
  * Retroactively mention #928932 in the 2.12.2~ds1-3 changelog entry.
  * Drop debian/source/lintian-overrides now that #964281 is fixed.
  * Make slice work standalone again. (Closes: #964678)
    + Move /usr/share/wml/TheWML/Backends/Slice/ from wml to slice.
    + Move /usr/share/wml/TheWML/CmdLine/IO.pm from wml to slice.
    + Add according Breaks and Replaces headers.
    + Let slice depend on libpath-tiny-perl and libclass-xsaccessor-perl.
    + Drop dependency on libbit-vector-perl from wml.

 -- Axel Beckert <abe@debian.org>  Fri, 10 Jul 2020 02:16:00 +0200

wml (2.28.0~ds1-1) unstable; urgency=low

  * New upstream release.
    + Drop patch fix-contrib-wml1to2-shebang-line.patch, obsolete.
    + Drop wml_include/TheWML/Frontends/Wml/PassesManager.pm,
      cmake/Shlomif_Common.cmake, cmake/preprocess-path-perl.pl and
      wml_frontend/CMakeLists.txt hunks from datadir-for-cmake-too.diff
    + Drop wml_contrib/wmg.cgi hunks from wml_2.0.11ds1-0.4.diff.
    + Drop wmd hunks from datadir-for-cmake-too.diff.
    + Update debian/{install,docs} wrt. files renamed or dropped upstream.
    + Refresh patches as needed.
    + Update test suite paths in override_dh_auto_test as needed.
    + Build the slice binary package from the wml source package. Recent
      wml versions (since approx. 2.20.x) are no more compatible with the
      old standalone slice. Rename debian/* to debian/wml.* as needed.
      - Cherry-pick fix-spelling-errors.diff from slice source package.
      - Cherry-pick remove-non-used-lib-dirs.diff from slice source
        package, but keep @INSTALLPRIVLIB@ as it's needed for
        /usr/share/wml/SliceTermParser.pm now.
      - Drop build-depedency on slice.
      - Let wml depend on slice >= 2.20.
      - Set a separate Homepage for the slice binary package.
    + Extend dont-use-usr-bin-env.patch to cover tkwmd.
    + Update datadir-for-cmake-too.diff to make libdir() behave like
      datadir() and drop /usr/lib/wml symlink. Fixes autopkgtest and
      lintian warning breakout-link.
  * Update lintian overrides to follow renamed lintian tags.
  * Add lintian override for national-encoding tag on isolatin.wml.
  * Add patch to fix national encoding in other files.
    + Add lintian override for national-encoding in the patch file. (See
      #964281 in lintian.)
  * Bump debhelper-compat to 13.
  * Declare compliance with Debian Policy 4.5.0. (No changes needed.)
  * debian/rules:
    + Move override_dh_auto_test before override_dh_*install*.
    + Always call "mv" with "-v".
    + Never call "ln" with "-i".
  * Mention in the package description when the recommended and suggested
    packages are needed.

 -- Axel Beckert <abe@debian.org>  Sun, 05 Jul 2020 04:00:47 +0200

wml (2.12.2~ds1-3) unstable; urgency=medium

  * Add patch to fix regression in Unicode handling (especially Chinese)
    of "htmlstrip -O2" from Stretch to Buster by adding "no feature
    'unicode_strings'". (Closes: #959761, #928932)

 -- Axel Beckert <abe@debian.org>  Tue, 05 May 2020 14:48:19 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: web
 Priority: optional
 Maintainer: Axel Beckert <abe@debian.org>
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                eperl <!nocheck>,
                freetable <!nocheck>,
                libbit-vector-perl,
@@ -25,7 +25,6 @@
                m4 <!nocheck>,
                mp4h <!nocheck>,
                perl (>= 5.8.0),
-               slice <!nocheck>,
                txt2html <!nocheck>,
                weblint-perl <!nocheck>,
                zlib1g-dev
@@ -38,7 +37,6 @@
 Architecture: all
 Depends: eperl (>= 2.2.14-2),
          libclass-xsaccessor-perl,
-         libbit-vector-perl,
          libcarp-always-perl,
          libfile-which-perl,
          libimage-size-perl,
@@ -48,7 +46,7 @@
          libterm-readkey-perl,
          m4 (>= 1.4-8),
          mp4h (>= 1.1.1-1),
-         slice (>= 1.3.7-0.1),
+         slice (>= 2.20),
          ${misc:Depends},
          ${perl:Depends}
 Recommends: iselect (>= 1.2.0-2),
@@ -75,3 +73,25 @@
  backends core languages. While not trivial and idiot proof WML provides
  most of the core features real hackers always wanted for HTML
  generation.
+ .
+ iselect is needed for wmd, the WML Documentation browser. The
+ remaining recommended or suggested packages are needed by optional
+ passes or libraries.
+
+Package: slice
+Homepage: https://github.com/thewml/website-meta-language/tree/master/src/wml_backend/p9_slice#readme
+Architecture: all
+Depends: libbit-vector-perl,
+         libclass-xsaccessor-perl,
+         libpath-tiny-perl,
+         perl,
+         ${misc:Depends},
+         ${perl:Depends}
+Breaks: wml (<< 2.28.0~ds1-2)
+Replaces: wml (<< 2.28.0~ds1-2)
+Description: Extract out pre-defined slices of an ASCII file
+ The slice program reads an input file and divide its prepared ASCII contents
+ into possibly overlapping slices. These slices are determined by enclosing
+ blocks which are defined by begin and end delimiters which have to be
+ already in the file. The final output gets calculated by a slice term
+ consisting of slice names, set theory operators and optional round brackets.

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 r = $(shell pwd)/debian/wml
 t = $(shell pwd)/debian/tmp
 o = $(shell pwd)/obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
-m = $(r)/usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+m = $(t)/usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 p = wml
 
 # Repackaging variables
@@ -26,30 +26,9 @@
 override_dh_auto_configure:
 	dh_auto_configure -- -DLIB_INSTALL_DIR=dummy
 
-override_dh_auto_install:
-	dh_auto_install -- prefix=$(r)/usr mandir=$(r)/usr/share/man INSTALLDIRS=perl
-	# Install icons for wml::std::logo
-	dh_auto_install -Dwml_misc -- libdir=$(r)/usr/share/wml
-
-	find $(r)/usr -type f -name .packlist -delete
-	find $(r) -type d -empty -delete
-	mv -v $(m)/wml $(r)/usr/share/
-	#   Fix documentation
-	for f in $(r)/usr/share/man/*/*; do \
-	   sed -e 's|.*/\([^/	]*\)	.*/\([^/	]*\)|s/\2/\1/|' debian/links |\
-	   sed -f - $$f > $$f.new && mv $$f.new $$f; \
-	done
-	rmdir -v $(m)/
-	# Don't ship wmu nor its man pages, its useless in distro (and deprecated anyways)
-	rm -f debian/wml/usr/share/man/man1/wmu.1* debian/wml/usr/bin/wmu
-
-override_dh_install:
-	dh_install
-	chmod 755 $(r)/usr/share/wml/contrib/tkwmd
-
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
-	cp -pvr wml_test/TEST* wml_test/t $(o)/wml_test/
+	cp -pvr wml_test/t $(o)/wml_test/
 	mkdir -pv $(o)/wml_test/tests/installation/lib/wml/exec/
 	ln -vis $(o)/wml_test/tests/installation/lib $(o)/wml_test/tests/installation/share
 	mkdir -pv $(o)/wml_test/tests/installation/bin/
@@ -61,16 +40,17 @@
 	cp -pv $(o)/wml_backend/p6_asubst/asubst.pl       $(o)/wml_test/tests/installation/lib/wml/exec/wml_p6_asubst
 	cp -pv $(o)/wml_backend/p7_htmlfix/htmlfix.pl     $(o)/wml_test/tests/installation/lib/wml/exec/wml_p7_htmlfix
 	cp -pv $(o)/wml_backend/p8_htmlstrip/htmlstrip.pl $(o)/wml_test/tests/installation/lib/wml/exec/wml_p8_htmlstrip
+	cp -pv $(o)/wml_backend/p9_slice/slice.pl $(o)/wml_test/tests/installation/lib/wml/exec/wml_p9_slice
 	mkdir -pv $(o)/wml_test/tests/installation/lib/perl5/include/ $(o)/wml_test/tests/installation/share/wml/include/
 	cp -pvr wml_include/TheWML/ $(o)/wml_test/tests/installation/lib/perl5/
+	cp -pv wml_backend/p9_slice/SliceTermParser.pm  $(o)/wml_test/tests/installation/lib/perl5/
 	cp -pvr $(o)/wml_include/TheWML/ $(o)/wml_test/tests/installation/lib/perl5/
 	cp -pvr $(o)/wml_include/???/ $(o)/wml_include/all.wml $(o)/wml_test/tests/installation/share/wml/include/
 	#dh_auto_install -- prefix=$(o)/wml_test/tests/installation/
-	ln -vis /usr/bin/mp4h  $(o)/wml_test/tests/installation/lib/wml/exec/wml_p2_mp4h
-	ln -vis /usr/bin/eperl $(o)/wml_test/tests/installation/lib/wml/exec/wml_p3_eperl
-	ln -vis /usr/bin/m4    $(o)/wml_test/tests/installation/lib/wml/exec/wml_p4_gm4
-	ln -vis /usr/bin/slice $(o)/wml_test/tests/installation/lib/wml/exec/wml_p9_slice
-	sed -e 's:/usr/\(lib\|share\)/wml:$(o)/wml_test/tests/installation/\1/wml:g; s:\(WML_LOC_.*\)=/usr:\1=$(o)/wml_test/tests/installation:g;' \
+	ln -vs /usr/bin/mp4h  $(o)/wml_test/tests/installation/lib/wml/exec/wml_p2_mp4h
+	ln -vs /usr/bin/eperl $(o)/wml_test/tests/installation/lib/wml/exec/wml_p3_eperl
+	ln -vs /usr/bin/m4    $(o)/wml_test/tests/installation/lib/wml/exec/wml_p4_gm4
+	sed -e 's:^\(my $$EXEC_DIR *=\).*:\1 "$(o)/wml_test/tests/installation/lib/wml/exec";:g; s:/usr/\(lib\|share\)/wml:$(o)/wml_test/tests/installation/\1/wml:g; s:\(WML_LOC_.*\)=/usr:\1=$(o)/wml_test/tests/installation:g;' \
 	    -i $(o)/wml_test/tests/installation/bin/wm? \
 	       $(o)/wml_test/tests/installation/lib/wml/exec/wml_p* \
 	       $(o)/wml_test/tests/installation/lib/perl5/TheWML/*.pm \
@@ -78,6 +58,31 @@
 	       $(o)/wml_test/tests/installation/lib/perl5/TheWML/*/*/*.pm
 	dh_auto_test
 endif
+
+override_dh_auto_install:
+	dh_auto_install -- prefix=$(t)/usr mandir=$(t)/usr/share/man INSTALLDIRS=perl
+	# Install icons for wml::std::logo
+	dh_auto_install -Dwml_misc -- libdir=$(t)/usr/share/wml
+
+	find $(t)/usr -type f -name .packlist -delete
+	find $(t) -type d -empty -delete
+	mv -v $(m)/wml/exec $(t)/usr/share/wml/
+	#   Fix documentation
+	for f in $(t)/usr/share/man/*/*; do \
+	   sed -e 's|.*/\([^/	]*\)	.*/\([^/	]*\)|s/\2/\1/|' debian/wml.links |\
+	   sed -f - $$f > $$f.new && mv -v $$f.new $$f; \
+	done
+	rmdir -v $(m)/wml $(m) $(t)/usr/lib
+	# Don't ship wmu nor its man pages, its useless in distro (and deprecated anyways)
+	rm -f $(t)/usr/share/man/man1/wmu.1* $(t)/usr/bin/wmu
+
+	# Install slice as /usr/bin/slice instead of /usr/share/wml/exec/wml_p9_slice
+	mv -v $(t)/usr/share/wml/exec/wml_p9_slice $(t)/usr/bin/slice
+	mv -v $(t)/usr/share/man/man1/wml_p9_slice.1 $(t)/usr/share/man/man1/slice.1
+
+override_dh_install:
+	dh_install
+	chmod 755 $(r)/usr/share/wml/contrib/tkwmd
 
 override_dh_installdocs:
 	dh_installdocs
